var info = {
	"C": ["Comment","The label field is the comment shown"],
	"CKB": ["Check","The extra field can contain a possible description shown to the right of the check box.\nCheck box can appears after another control.\n"],
	"CKL": ["Checklist","This type generates a set of check boxes.\nThe extra field contains a list of field names separated by , (comma); "
		+ "the field name is key if present, otherwise is value; value is the description that appears after the check box."
		+ "\nThe view name become a hidden text field that contains the number of check boxes selected."],
	"CMB": ["Combo","Drop Down list: permits to choice a value from a list.\n"
		+"The extras fields contain the items in the form: key=value.\n"
		+"If there is only one combo (type CMB) in the form, the form has no buttons and it is exited when a list item is selected/n"
		+"It is possible to have a combo with items separated on group (optgroup tag), the group is identified by the syntax |=groupLabel:"],
	"B": ["Button","Button, the label field is the caption of button, the length, if present, is the dimension in pixels.\n"
		+"The extra field can contains a name of function which is called instead of the internal function for submit.\nThe second possible extra field become the argument of title tag."],
	"GB": ["ImgButton","Graphic button (or IB: Image button), the label field contains the source of the image.\nThe length, if present, is the dimension in pixels.\n"
		+"The extra field can contains a name of function which is called instead of the internal function for submit.\nThe second possible extra field become the argument of title tag."],
	"C": ["Comment","The label field is the comment shown"],
	"Date": ["Date","HTML 5 Supported on Chrome and Opera"],
	"F": ["File","F or FILE: the extra field can contains a file filter(s), if many, they are separated by comma:\n"
		+"file_extension|audio/*|video/*|image/*|media_type"],
	"H": ["Hidden","An hidden field."],
	"I": ["Image","Show an image\nthe length can contain the image height\nextra1 is the image file\nextra 2 is title"],
	"L": ["List","L or LIST: is a text box associated to a list.\nThe items are on extra field separated by comma."],
	"N": ["Number","Number"],
	"NS": ["Signednumber","Signed number"],
	"NF": ["Decimalnumber","Decimal number"],
	"P": ["Password","Password field"],
	"R": ["Rdb","The extras fields contain the labels and value of each radio button.\nTo obtain a key instead of the label, the item must have the form: key=value:\n"
		+"Rdb,Status,,45,M=Married,S=Single,W=Widow\nThe length field determine the distance in pixel from the radio buttons items."],
	"RV": ["vRdb","The extras fields contain the labels and value of each radio button.\nTo obtain a key instead of the label, the item must have the form: key=value:\n"
		+"The radio buttons are arranged vertically.\nRdb,Status,,45,M=Married,S=Single,W=Widow"],
	"S": ["Slider","S or SLIDER: the length of the slider is in pixel (default 150)./nThe extra field can contains the start, end and step values in the form start,end,step/n"
		+"e.g. -5,5,0.5; if it is omitted, the values assumed are 0 100 and 1. The result can have decimals depending on the difference from start and end value."],
	"T": ["Text","TEXT is synonym of T.\nIf the length exceed 50 characters it is generated a text area.\nThe extra field, if present, contains a text hint (HTML5 place-holder property)."],
	"U": ["Unmodifiable","A protect text field."]
}
var samples = {	// extra field
	"B": ",Button title tag.",
	"CKB": "This is a Check box",
	"CKL": "C=C\\x2cC++\\x2cC#,JS=JavaScript,PHP,PYTHON,RUBY,RUST",
	"CMB": "|=Linear,mm=millimeter,cm=centimeter,m=meter,km=kilometer,|=Weight,g=gram,kg=kilogram,t=ton",
	"GB": ",Button title tag.",
	"H": "Hidden data",
	"I": "images/condor.gif,Image title",
	"L": "Alpha,Beta,Delta,Gamma",
	"F": ".gif,.jpg,.png",
	"R": "M=Married,S=Single,W=Widow",
	"RV": "North,South,West,East",
	"S": "-5,5,0.5",
	"T": "place holder",
	"U": "Unmodifiable field."
}
aSandBox = ["Form,frm,Try Sand Box,echo.php,receive;"];		// commands array
function receive(c) {
	$("result2").innerHTML = c;
}
function controlWhithdraw(frm,field,value) {	// check Quantity withdrawn
	if (value > parseFloat(frm["Qty"].value)) return false;
	return true;
}
function sandBox(x) {
	$("frmg#_help").value = info[x][1];
	$("frmg#_Mail").disabled = (x != "T");
	if (x != "T") $("frmg#_Mail").checked = false;
	$("fg_list").value = aSandBox.join("\n");
	$("frmg#_name").value = "";
	$("frmg#_label").value = "";
	$("frmg#_length").value = "";
	$("frmg#_extra").value = "";
	insertSample();	
}
function insertSample() {
	$("frmg#_name").value = info[$("frmg#_type").value][0] + aSandBox.length;
	$("frmg#_label").value = info[$("frmg#_type").value][0] + " " + aSandBox.length;
	var type = $("frmg#_type").value;
	if (typeof samples[type] != "undefined") $("frmg#_extra").value = samples[type];
	if (type == "S") {
		$("frmg#_length").value = 150;
	} else if (type == "NF") {
		$("frmg#_default").value = "3.1415";
	} else if (type == "NS") {
		$("frmg#_default").value = "-121";
	}
}
function receiveDataForm(frm) {
	if (frm.elements["fg_Button"].value != "fg_Cancel") {
		var res = "";
		if ($("fg_list").innerHTML == "") res = "Form,frm,Form Generator;\n"
		res += frm["frmg#_type"].value + "," + frm["frmg#_name"].value + "," + frm["frmg#_label"].value + ",";
		res += frm["frmg#_length"].value + "," + frm["frmg#_extra"].value + ";";
		aSandBox[aSandBox.length] = res
		if (frm["frmg#_Required"].checked) aSandBox[aSandBox.length] = "Control," + frm["frmg#_name"].value + ",required;";
		if (frm["frmg#_Mail"].checked) aSandBox[aSandBox.length] = "Control," + frm["frmg#_name"].value + ",mail;";
		if (frm["frmg#_default"].value != "") aSandBox[aSandBox.length] = "Defaults," + frm["frmg#_name"].value + "=" + frm["frmg#_default"].value + ";";
		$("fg_list").value = aSandBox.join("\n");
	}
}
var popUpInfo = `Use:<br>popUp(parameters)
	<br>Where parameters is for example:<br>
	{"id":"","cancel":"Delete","top":"-1","left":"-1","width":"-1",
	"height":"-1","content":popUpInfo,"style":"background:#ccc"}
	<br>`;
function popUpHelp() {
	var cancelType = $("Cancel").value;
	if (cancelType.toLowerCase() == "click") var howCancel = "Click for cancel";
	else var howCancel =  `Hit ${cancelType} key for cancel`;
	var cancel = $("Cancel").value;
	cancel = (isNaN(cancel)) ? cancel:Number(cancel);
	var parms = {"id":"","cancel":cancel,
				"top":$("Top").value,"left":$("Left").value,"width":$("Width").value,"height":$("Height").value,
				"content":popUpInfo+howCancel,"style":"background:#ccc"};
	popUp(parms);
	return false;
}